//+------------------------------------------------------------------+
//|                                                    MagicDoji.mq4 |
//|                                       Copyright  2008, Limstylz |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Limstylz"
#property link      ""

extern int DojiMagic=99991234, Slippage=3;
extern double Lots, Take_Profit=10,StopLoss,Expiration,ConcurrentTrades;
extern bool   MoneyManagement = true;
extern double EquityLow = 1,EquityHigh,pcIncrease,BaseEquity=3500,ExitBalance, DeleteActiveTrades;
int ticket;
bool StopTrade;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
  {
   double dclose = Close[1], dopen  = Open[1], dhigh = High[1], dlow = Low[1], copen=iOpen(NULL,0,0),Price;
   double vol = iVolume(NULL,0,0), TP= Take_Profit*Point, SL=StopLoss*Point,Stop;
   double Diff=MarketInfo(Symbol(),MODE_STOPLEVEL), VDiff=Diff*Point;
   int Exp= TimeCurrent()+ (Expiration*60),total = OrdersTotal(),cnt = 0;
   bool bought = false, sold = false;
      
   if (Expiration==0){Exp=0;}

   if (MoneyManagement)     
      {
         Lots=MathFloor((AccountBalance()*pcIncrease)/(MarketInfo(Symbol(),MODE_LOTSIZE)*MarketInfo(Symbol(),MODE_MINLOT)))*MarketInfo(Symbol(),MODE_MINLOT);
            }
   
   
   for (cnt = total ; cnt >=0 ; cnt-- )
      {
         OrderSelect(0,SELECT_BY_POS,MODE_TRADES);
            if (AccountEquity ()< (AccountBalance() - (AccountBalance()*EquityLow)/100) || (AccountEquity() >= (AccountBalance() + (AccountBalance()*EquityHigh)/100)) || AccountEquity()>=ExitBalance)
              // {if(OrderType()==OP_BUY)
                //  OrderClose(OrderTicket(),OrderLots(),copen,3,Red);
                  //   if(OrderType()==OP_SELL) 
                    //    OrderClose(OrderTicket(),OrderLots(),copen,3,Red);
                      {     if(OrderType()>OP_SELL)
                              OrderDelete(OrderTicket());
                                 StopTrade=true;}
                                    }
   
   for (cnt = total ; cnt >=0 ; cnt-- )
         {
            OrderSelect(0,SELECT_BY_POS,MODE_TRADES);
               if ((TimeCurrent() - OrderOpenTime() > (DeleteActiveTrades*60) && OrderProfit() <0) || AccountEquity()>=ExitBalance)
                  {if(OrderType()==OP_BUY)
                     OrderClose(OrderTicket(),OrderLots(),Ask,3,Red);
                        if(OrderType()==OP_SELL) 
                           OrderClose(OrderTicket(),OrderLots(),Bid,3,Red);}
                             // if(OrderType()>OP_SELL)
                               //  OrderDelete(OrderTicket());
                                    //StopTrade=true;}
                                       }
      
      if (dclose==dopen && vol<=1 && OrdersTotal() < ConcurrentTrades && (AccountEquity ()> (AccountBalance() -(AccountBalance()*EquityLow)/100)) && (AccountEquity() < (AccountBalance() + (AccountBalance()*EquityHigh)/100)) && AccountEquity() >= BaseEquity  && AccountEquity ()< ExitBalance && StopTrade==false)
         {
            if (Bid==dlow)
               {
                  Price=Bid; Stop=Price+SL;
                     if (SL==0){Stop=0;}
                        ticket=OrderSend(Symbol(),OP_SELL,Lots,Price,Slippage,Stop,Price-TP,"DojiMagic OP_SELL 1", DojiMagic,Exp,Magenta);
                           Print("OP_SELL 1 = ", GetLastError());
                              sold = true;
                                 }
      
            if (Ask == dhigh)
               {
                  Price = Ask;Stop=Price-SL;
                     if (SL==0){Stop=0;}
                        ticket=OrderSend(Symbol(),OP_BUY,NormalizeDouble(Lots,Digits),Price,Slippage,Stop,Price+TP,"DojiMagic OP_BUY 1", DojiMagic,Exp,RoyalBlue);
                           Print("OP_BUY 1 = ", GetLastError());
                              bought = true;
                                 }

            if (sold==false && Bid <= dclose && Bid - VDiff <= dlow)
               {
                  Price = Bid - VDiff; Stop=Price+SL;
                     if (SL==0){Stop=0;}
                        ticket = OrderSend(Symbol(),OP_SELLSTOP,NormalizeDouble(Lots,Digits),Price,Slippage,Stop,Price-TP,"DojiMagic OP_SELLSTOP 1", DojiMagic,Exp,Magenta);
                           Print("OP_SELLSTOP 1 = ", GetLastError());
                              sold = true;
                                 }

            if (sold==false && Bid <= dclose && Bid - VDiff >= dlow)
               {
                  Price = dlow; Stop=Price+SL;
                     if (SL==0){Stop=0;}
                        ticket = OrderSend(Symbol(),OP_SELLSTOP,NormalizeDouble(Lots,Digits),Price,Slippage,Stop,Price-TP,"DojiMagic OP_SELLSTOP 2", DojiMagic,Exp,Magenta);
                           Print("OP_SELLSTOP 2 = ", GetLastError());
                              sold = true;
                                 }      

            if (sold==false && Bid >= dclose && Bid - VDiff >= dlow)
               {
                  Price = dlow; Stop=Price+SL;
                     if (SL==0){Stop=0;}
                        ticket = OrderSend(Symbol(),OP_SELLSTOP,NormalizeDouble(Lots,Digits),Price,Slippage,Stop+SL,Price-TP,"DojiMagic OP_SELLSTOP 3", DojiMagic,Exp,Magenta);
                           Print("OP_SELLSTOP 3 = ", GetLastError());
                              sold = true;
                                 }      

            if (sold==false && Bid >= dclose && Bid - VDiff <= dlow)
               {
                  Price = Bid - VDiff; Stop=Price+SL;
                     if (SL==0){Stop=0;}
                        ticket = OrderSend(Symbol(),OP_SELLSTOP,NormalizeDouble(Lots,Digits),Price,Slippage,Stop,Price-TP,"DojiMagic OP_SELLSTOP 4", DojiMagic,Exp,Magenta);
                           Print("OP_SELLSTOP 4 = ", GetLastError());
                              sold = true;
                                 }      


            if (bought==false && Ask <= dclose && Ask + VDiff <= dhigh)
               {
                  Price = dhigh; Stop=Price-SL;
                     if (SL==0){Stop=0;}
                        ticket=OrderSend(Symbol(),OP_BUYSTOP,NormalizeDouble(Lots,Digits),Price,Slippage,Stop,Price+TP,"DojiMagic OP_BUYSTOP 1", DojiMagic,Exp,RoyalBlue);
                           Print("OP_BUYSTOP 1 = ", GetLastError());
                              bought = true;
                                 }      

            if (bought==false && Ask <= dclose && Ask + VDiff >= dhigh)
               {
                  Price = Ask + VDiff; Stop=Price-SL;
                     if (SL==0){Stop=0;}
                        ticket=OrderSend(Symbol(),OP_BUYSTOP,NormalizeDouble(Lots,Digits),Price,Slippage,Stop,Price+TP,"DojiMagic OP_BUYSTOP 2", DojiMagic,Exp,RoyalBlue);
                           Print("OP_BUYSTOP 2 = ", GetLastError());
                              bought = true;
                                 }      

            if (bought==false && Ask >= dclose && Ask + VDiff >= dhigh)
               {
                  Price = Ask + VDiff; Stop=Price-SL;
                     if (SL==0){Stop=0;}
                        ticket=OrderSend(Symbol(),OP_BUYSTOP,NormalizeDouble(Lots,Digits),Price,Slippage,Stop,Price+TP,"DojiMagic OP_BUYSTOP 4", DojiMagic,Exp,RoyalBlue);
                           Print("OP_BUYSTOP 4 = ", GetLastError());
                              bought = true;
                                 }      

            if (bought==false && Ask >= dclose && Ask + VDiff <= dhigh)
            
               {
                  Price = dhigh; Stop=Price-SL;
                     if (SL==0){Stop=0;}
                        ticket=OrderSend(Symbol(),OP_BUYSTOP,NormalizeDouble(Lots,Digits),Price,Slippage,Stop,Price+TP,"DojiMagic OP_BUYSTOP 3", DojiMagic,Exp,RoyalBlue);
                           Print("OP_BUYSTOP 3 = ", GetLastError());
                              bought = true;
                                 }     
                                    }
      if (dclose==dopen && vol<=1 && (OrdersTotal() > ConcurrentTrades))
         {
            Print("Total Active/Pending Orders= ", OrdersTotal());
               }
  }
      
//----
   return(0);
   }
//+------------------------------------------------------------------+